&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*------------------------------------------------------------------------
  File: mailtest.w
  Description: Simple GUI for testing smtpmail.p
  Input Parameters:
      <none>
  Output Parameters:
      <none>
  Author: S.E. Southwell - BravePoint, Inc.
  Created: 8/22/02
  Copyright: The FreeFrameWork Project, Inc.  Use in accordance with 
             the FreeFrameWork License.
  Notes:     This program is quick-and-dirty, and could use some sprucing up.
             Any GUI gurus, please feel free!
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Preprocessors / Constants */

&GLOBAL-DEFINE DEFAULT_SMTP_SERVER "mail.freeframework.org"

/* Local Variable Definitions ---                                       */


DEFINE VARIABLE v-successful AS LOGICAL   NO-UNDO.
DEFINE VARIABLE v-message    AS CHARACTER NO-UNDO.
DEFINE VARIABLE v-textin     AS CHARACTER NO-UNDO.
DEFINE VARIABLE v-selectOK AS LOGICAL NO-UNDO.
DEFINE VARIABLE v-filenamechosen AS CHARACTER NO-UNDO.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME DEFAULT-FRAME

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS fiSMTPServer fiTo fiCC fiFrom fiSubject ~
rsBodyType eBody eAttachments eLocalFiles fiMimeType fiCharSet fiFileType ~
btnSend btnStop fiSuccessful eMessage 
&Scoped-Define DISPLAYED-OBJECTS fiSMTPServer fiTo fiCC fiFrom fiSubject ~
rsBodyType fiFileName eBody eAttachments eLocalFiles fiMimeType fiCharSet ~
fiFileType fiSuccessful eMessage 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON btnBrowse 
     LABEL "..." 
     SIZE 5 BY .95.

DEFINE BUTTON btnSend 
     LABEL "Send" 
     SIZE 15 BY 1.14.

DEFINE BUTTON btnStop 
     LABEL "Stop" 
     SIZE 15 BY 1.14.

DEFINE VARIABLE eAttachments AS CHARACTER 
     VIEW-AS EDITOR NO-WORD-WRAP SCROLLBAR-HORIZONTAL SCROLLBAR-VERTICAL
     SIZE 72 BY 4 TOOLTIP "file[:type=<mimetype>][:charset=<charset>][:filetype=<filetype>]" NO-UNDO.

DEFINE VARIABLE eBody AS CHARACTER 
     VIEW-AS EDITOR NO-WORD-WRAP SCROLLBAR-HORIZONTAL SCROLLBAR-VERTICAL
     SIZE 68 BY 9.05 NO-UNDO.

DEFINE VARIABLE eLocalFiles AS CHARACTER 
     VIEW-AS EDITOR NO-WORD-WRAP SCROLLBAR-HORIZONTAL SCROLLBAR-VERTICAL
     SIZE 72 BY 4.05 NO-UNDO.

DEFINE VARIABLE eMessage AS CHARACTER 
     VIEW-AS EDITOR NO-WORD-WRAP SCROLLBAR-HORIZONTAL SCROLLBAR-VERTICAL
     SIZE 100 BY 5 NO-UNDO.

DEFINE VARIABLE fiCC AS CHARACTER FORMAT "X(256)":U 
     LABEL "CC" 
     VIEW-AS FILL-IN 
     SIZE 72 BY 1 NO-UNDO.

DEFINE VARIABLE fiCharSet AS CHARACTER FORMAT "X(256)":U 
     LABEL "Charset" 
     VIEW-AS FILL-IN 
     SIZE 16 BY 1 NO-UNDO.

DEFINE VARIABLE fiFileName AS CHARACTER FORMAT "X(256)":U 
     VIEW-AS FILL-IN 
     SIZE 55 BY 1 NO-UNDO.

DEFINE VARIABLE fiFileType AS CHARACTER FORMAT "X(256)":U 
     LABEL "FileType" 
     VIEW-AS FILL-IN 
     SIZE 17 BY 1 NO-UNDO.

DEFINE VARIABLE fiFrom AS CHARACTER FORMAT "X(256)":U 
     LABEL "From" 
     VIEW-AS FILL-IN 
     SIZE 72 BY 1 NO-UNDO.

DEFINE VARIABLE fiMimeType AS CHARACTER FORMAT "X(256)":U 
     LABEL "MIMEType" 
     VIEW-AS FILL-IN 
     SIZE 20 BY 1 NO-UNDO.

DEFINE VARIABLE fiSMTPServer AS CHARACTER FORMAT "X(256)":U 
     LABEL "SMTP Server" 
     VIEW-AS FILL-IN 
     SIZE 72 BY 1 NO-UNDO.

DEFINE VARIABLE fiSubject AS CHARACTER FORMAT "X(256)":U 
     LABEL "Subject:" 
     VIEW-AS FILL-IN 
     SIZE 72 BY .95 NO-UNDO.

DEFINE VARIABLE fiSuccessful AS LOGICAL FORMAT "yes/no":U INITIAL NO 
     LABEL "Success?" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

DEFINE VARIABLE fiTo AS CHARACTER FORMAT "X(256)":U 
     LABEL "To" 
     VIEW-AS FILL-IN 
     SIZE 72 BY 1 NO-UNDO.

DEFINE VARIABLE rsBodyType AS CHARACTER 
     VIEW-AS RADIO-SET VERTICAL
     RADIO-BUTTONS 
          "Body from file:", "file",
"Body from text:", "text"
     SIZE 19 BY 3 NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DEFAULT-FRAME
     fiSMTPServer AT ROW 1.71 COL 18 COLON-ALIGNED
     fiTo AT ROW 3.14 COL 18 COLON-ALIGNED
     fiCC AT ROW 4.57 COL 18 COLON-ALIGNED
     fiFrom AT ROW 6 COL 18 COLON-ALIGNED
     fiSubject AT ROW 7.43 COL 18 COLON-ALIGNED
     rsBodyType AT ROW 8.86 COL 4 NO-LABEL
     fiFileName AT ROW 9.1 COL 22 COLON-ALIGNED NO-LABEL
     btnBrowse AT ROW 9.1 COL 81
     eBody AT ROW 10.76 COL 24 NO-LABEL
     eAttachments AT ROW 20.76 COL 20 NO-LABEL
     eLocalFiles AT ROW 25.05 COL 20 NO-LABEL
     fiMimeType AT ROW 29.81 COL 18 COLON-ALIGNED
     fiCharSet AT ROW 29.81 COL 47 COLON-ALIGNED
     fiFileType AT ROW 29.81 COL 73 COLON-ALIGNED
     btnSend AT ROW 31.48 COL 30
     btnStop AT ROW 31.48 COL 50
     fiSuccessful AT ROW 32.91 COL 16 COLON-ALIGNED
     eMessage AT ROW 34.33 COL 3 NO-LABEL
     "Attachments:" VIEW-AS TEXT
          SIZE 13 BY .62 AT ROW 20.76 COL 6
     "Local Files:" VIEW-AS TEXT
          SIZE 12 BY .62 TOOLTIP "File names of attachements above - comma separated" AT ROW 25.05 COL 7
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 102.8 BY 38.57.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "SMTPMail Tester"
         HEIGHT             = 38.57
         WIDTH              = 102.8
         MAX-HEIGHT         = 38.57
         MAX-WIDTH          = 102.8
         VIRTUAL-HEIGHT     = 38.57
         VIRTUAL-WIDTH      = 102.8
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME DEFAULT-FRAME
                                                                        */
/* SETTINGS FOR BUTTON btnBrowse IN FRAME DEFAULT-FRAME
   NO-ENABLE                                                            */
ASSIGN 
       eMessage:READ-ONLY IN FRAME DEFAULT-FRAME        = TRUE.

/* SETTINGS FOR FILL-IN fiFileName IN FRAME DEFAULT-FRAME
   NO-ENABLE                                                            */
ASSIGN 
       fiSuccessful:READ-ONLY IN FRAME DEFAULT-FRAME        = TRUE.

IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* SMTPMail Tester */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* SMTPMail Tester */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnBrowse
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnBrowse C-Win
ON CHOOSE OF btnBrowse IN FRAME DEFAULT-FRAME /* ... */
DO:
    SYSTEM-DIALOG GET-FILE v-filenamechosen UPDATE v-selectOK.
    IF v-selectOK THEN DO:
        fiFilename:SCREEN-VALUE IN FRAME {&FRAME-NAME} = v-filenamechosen.
    END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnSend
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnSend C-Win
ON CHOOSE OF btnSend IN FRAME DEFAULT-FRAME /* Send */
DO:
  OS-DELETE VALUE("socketemail.log").
  
  ASSIGN
   btnSend:SENSITIVE = FALSE
   btnStop:SENSITIVE = TRUE
   fiSuccessful:SCREEN-VALUE = ?
   eMessage:SCREEN-VALUE = ""
  .
  
  RUN ffw/procs/smtpmail53.p(
    fiSMTPServer:SCREEN-VALUE,
    fiTo:SCREEN-VALUE,
    fiFrom:SCREEN-VALUE,
    fiCC:SCREEN-VALUE,
    eAttachments:SCREEN-VALUE,
    eLocalFiles:SCREEN-VALUE,
    fiSubject:SCREEN-VALUE,
    IF rsBodyType = "text" THEN eBody:SCREEN-VALUE ELSE fiFileName:SCREEN-VALUE,
    "",
    rsBodyType:SCREEN-VALUE,
    OUTPUT v-successful,
    OUTPUT v-message
  ) NO-ERROR.
  IF ERROR-STATUS:ERROR THEN MESSAGE ERROR-STATUS:GET-MESSAGE(1) VIEW-AS ALERT-BOX.
  
  ASSIGN                          
   btnStop:SENSITIVE = FALSE
   btnSend:SENSITIVE = TRUE
   fiSuccessful:SCREEN-VALUE = STRING(v-successful)
   eMessage:SCREEN-VALUE = v-message
  .
  
  INPUT FROM VALUE("socketemail.log").
  REPEAT:
      IMPORT UNFORMATTED v-textin.
      ASSIGN eMessage:SCREEN-VALUE = eMessage:SCREEN-VALUE + "~n" + v-textin.
  END.
  INPUT CLOSE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME rsBodyType
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL rsBodyType C-Win
ON VALUE-CHANGED OF rsBodyType IN FRAME DEFAULT-FRAME
DO:
  IF rsBodyType:SCREEN-VALUE = "file" THEN do:
    ENABLE fiFileName WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
    DISABLE eBody WITH FRAME DEFAULT-FRAME.
    btnBrowse:SENSITIVE = TRUE.
  END.
  ELSE do:
    ENABLE eBody WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
    DISABLE fifileName WITH FRAME DEFAULT-FRAME.
    btnBrowse:SENSITIVE = FALSE.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
   RUN disable_UI.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  
  RUN enable_UI.
  ASSIGN 
   fiSuccessful:SCREEN-VALUE = ?
   fiSMTPServer:SCREEN-VALUE = {&DEFAULT_SMTP_SERVER}
   rsBodyType:SCREEN-VALUE = "text"
  .
   
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
  THEN DELETE WIDGET C-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY fiSMTPServer fiTo fiCC fiFrom fiSubject rsBodyType fiFileName eBody 
          eAttachments eLocalFiles fiMimeType fiCharSet fiFileType fiSuccessful 
          eMessage 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  ENABLE fiSMTPServer fiTo fiCC fiFrom fiSubject rsBodyType eBody eAttachments 
         eLocalFiles fiMimeType fiCharSet fiFileType btnSend btnStop 
         fiSuccessful eMessage 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

